package com.gyee.edge.gateway.message;

import com.gyee.edge.common.utils.ByteUtil;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import lombok.Data;
import java.io.*;
import java.util.List;

@Data
public class GYMessage implements Serializable {
    private byte[] header=new byte[]{'G','Y','F','P','V','2','0','0'};
    private short length;
    private short count;
    private int attribute;
    private List<MessageData> messageDataList;
    private MessageMutable messageMutable;



     public byte[] toBytes(){
         //不指定默认256，指定64以内默认大小都是64.
         /*如果写入后数据大小未超过512个字节，则选择下一个16的整数倍进行扩容。比如写入数据后大小为12，则扩容后的capacity是16。
         如果写入后数据大小超过512个字节，则选择下一个2n。比如写入后大小是512字节，则扩容后的capacity是210=1024。(因为29=512，长度已经不够了)
         扩容不能超过max capacity，否则会报错*/
         ByteBuf buffer = Unpooled.buffer(10);
         buffer.writeBytes(getHeader());
         buffer.writeShort(getLength());
         buffer.writeShort(getCount());
         buffer.writeInt(getAttribute());
         buffer.writeBytes(getMessageMutable().toBytes(getAttribute()));
         for (MessageData messageData : getMessageDataList()){
             buffer.writeBytes(messageData.toBytes(getAttribute()));
         }
         return buffer.touch().array();
     }

     public GYMessage toObject(byte[] bytes){
         GYMessage gyMessage = new GYMessage();
         gyMessage.setLength(ByteUtil.getShort(bytes,8));
         gyMessage.setCount(ByteUtil.getShort(bytes,11));
         gyMessage.setAttribute(ByteUtil.getInt(bytes,12));
         gyMessage.setMessageMutable(getMessageMutable().toObject(bytes,getAttribute()));
         gyMessage.setMessageDataList(MessageData.toObject(bytes,getAttribute()));
         return gyMessage;
     }







}
