package com.gyee.edge.gateway.message;

import com.gyee.edge.common.utils.ByteUtil;
import lombok.Data;

import java.io.Serializable;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;
import java.util.ArrayList;
import java.util.List;

@Data
public class MessageData implements Serializable {
    private int dataKey;
    private int ts;
    private byte dataType;
    private float dataValue;


    public byte[] toBytes(int attribute){
        ByteBuffer byteBuffer = ByteBuffer.allocate(11).order(ByteOrder.BIG_ENDIAN);
        if(attribute==0){
            byteBuffer.putFloat(getDataValue());
        }else if(attribute==1){
            byteBuffer.putInt(getDataKey());
            byteBuffer.putFloat(getDataValue());
        }else if(attribute==2){
            byteBuffer.putInt(getTs());
            byteBuffer.putFloat(getDataValue());
        }else if (attribute==3){
            byteBuffer.put(getDataType());
            byteBuffer.putInt(getTs());
            byteBuffer.putFloat(getDataValue());
        }return byteBuffer.array();
    }

    public static List<MessageData> toObject(byte[] bytes, int attribute) {
        List<MessageData> messageDataList = new ArrayList<>();
        int count = bytes.length - 25;
        byte[] bytes1 = new byte[count];
        System.arraycopy(bytes, 25, bytes1, 0, count);
        for (int i = 0; i < bytes1.length; i=i+11) {
            MessageData messageData = new MessageData();
            if (attribute == 0) {
                messageData.setDataValue(ByteUtil.getFloat(bytes1,i));
            } else if (attribute == 1) {
                messageData.setDataKey(ByteUtil.getInt(bytes1,i));
                messageData.setDataValue(ByteUtil.getFloat(bytes1,i+4));
            } else if (attribute == 2) {
                messageData.setTs(ByteUtil.getInt(bytes1,i));
                messageData.setDataValue(ByteUtil.getFloat(bytes1,i+4));
            } else if (attribute == 3) {
                messageData.setDataType(bytes1[i]);
                messageData.setTs(ByteUtil.getInt(bytes1,i+1));
                messageData.setDataValue(ByteUtil.getFloat(bytes1,i+5));
            }
            messageDataList.add(messageData);
        }
        return messageDataList;
    }
}
