package com.gyee.edge.gateway.message;


import com.gyee.edge.common.utils.ByteUtil;
import lombok.Data;

import java.io.Serializable;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;


@Data
public class MessageMutable implements Serializable {
    private byte messageType;
    private int key;
    private int ts;

    public byte[] toBytes(int attribute){
        ByteBuffer byteBuffer = ByteBuffer.allocate(9).order(ByteOrder.BIG_ENDIAN);
        if(attribute==0){
            byteBuffer.putInt(getKey());
        }else if(attribute==1){
            byteBuffer.put(getMessageType());
        }else if (attribute==2){
            byteBuffer.putInt(getTs());
        }else if(attribute==3){
            byteBuffer.put(getMessageType());
            byteBuffer.putInt(getKey());
            byteBuffer.putInt(getTs());
        }
        byte[] array = byteBuffer.array();
        return array;
    }

    public MessageMutable toObject(byte[] bytes,int attribute){
        byte[] bytes1 = new byte[9];
        System.arraycopy(bytes,16,bytes1,0,9);
        MessageMutable messageMutable = new MessageMutable();
        if(attribute==0){
            messageMutable.setKey(ByteUtil.getInt(bytes1,0));
        }else if(attribute==1){
            messageMutable.setMessageType(bytes1[0]);
        }else if (attribute==2){
            messageMutable.setTs(ByteUtil.getInt(bytes1,0));
        }else if(attribute==3){
            messageMutable.setMessageType(bytes1[0]);
            messageMutable.setKey(ByteUtil.getInt(bytes1,1));
            messageMutable.setTs(ByteUtil.getInt(bytes1,5));
        }
        return messageMutable;
    }
}
