package com.gyee.edge.loader.golden;


import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.gyee.edge.loader.data.Datas;
import com.gyee.edge.loader.data.GeneralTsData;
import com.gyee.edge.loader.data.TsPointData;
import com.gyee.edge.loader.data.User;
import com.gyee.edge.loader.service.SqlService;

import lombok.extern.slf4j.Slf4j;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.*;

@Slf4j
@Component
public class DataWrite {
    @Autowired
    private SqlService sqlService;

    public void DataWriteGloden(String jsonObject) throws Exception {
        List<TsPointData> tsDataList = new ArrayList<>();
        try {
            Date ts = new Date();
            System.out.println("写入golden前时间"+(ts.getTime()));
            //通过 proto Json 数据转 Java 对象
            Gson GSON = new GsonBuilder().serializeNulls().create();
            User user3 = GSON.fromJson(jsonObject, User.class);
            Map<String, Datas> maps =  user3.getMap();
            for (Map.Entry<String, Datas> entry:maps.entrySet()){
                TsPointData tsPointData = new TsPointData();
                GeneralTsData generalTsData = new GeneralTsData();
                tsPointData.setTagName(entry.getKey());
                generalTsData.setTs(entry.getValue().getTs());
                double value = entry.getValue().getValue();
                generalTsData.setDoubleValue(Optional.ofNullable(Double.valueOf(value)));
                tsPointData.setTsData(generalTsData);
                tsDataList.add(tsPointData);
            }
            sqlService.saveDataSnaps(tsDataList);
            Date es = new Date();
            System.out.println("写入golden后时间"+(ts.getTime()));
            log.info("写入golden时间"+(es.getTime()-ts.getTime()));
        }catch (Exception e){
            log.error("转化map发生异常",e);
        }
    }

}
